> [!NOTE]
> **Note:** To get more information about this package, such as access to older versions, view [this package on pkg.go.dev](https://pkg.go.dev/google.golang.org/appengine/v2/blobstore).

<br />

Package blobstore provides a client for App Engine's persistent blob
storage service.

## Functions

### func BlobKeyForFile

```go
func BlobKeyForFile(c context.Context, filename string) (appengine.BlobKey, error)
```
BlobKeyForFile returns a BlobKey for a Google Storage file.
The filename should be of the form "/gs/bucket_name/object_name".

### func Delete

```go
func Delete(c context.Context, blobKey appengine.BlobKey) error
```
Delete deletes a blob.

### func DeleteMulti

```go
func DeleteMulti(c context.Context, blobKey []appengine.BlobKey) error
```
DeleteMulti deletes multiple blobs.

### func ParseUpload

```go
func ParseUpload(req *http.Request) (blobs map[string][]*BlobInfo, other url.Values, err error)
```
ParseUpload parses the synthetic POST request that your app gets from
App Engine after a user's successful upload of blobs. Given the request,
ParseUpload returns a map of the blobs received (keyed by HTML form
element name) and other non-blob POST parameters.

### func Send

```go
func Send(response http.ResponseWriter, blobKey appengine.BlobKey)
```
Send sets the headers on response to instruct App Engine to send a blob as
the response body. This is more efficient than reading and writing it out
manually and isn't subject to normal response size limits.

### func UploadURL

```go
func UploadURL(c context.Context, successPath string, opts *UploadURLOptions) (*url.URL, error)
```
UploadURL creates an upload URL for the form that the user will
fill out, passing the application path to load when the POST of the
form is completed. These URLs expire and should not be reused. The
opts parameter may be nil.

## BlobInfo

```go
type BlobInfo struct {
	BlobKey      appengine.BlobKey
	ContentType  string    `datastore:"content_type"`
	CreationTime time.Time `datastore:"creation"`
	Filename     string    `datastore:"filename"`
	Size         int64     `datastore:"size"`
	MD5          string    `datastore:"md5_hash"`

	// ObjectName is the Google Cloud Storage name for this blob.
	ObjectName string `datastore:"gs_object_name"`
}
```
BlobInfo is the blob metadata that is stored in the datastore.
Filename may be empty.

### func Stat

```go
func Stat(c context.Context, blobKey appengine.BlobKey) (*BlobInfo, error)
```
Stat returns the BlobInfo for a provided blobKey. If no blob was found for
that key, Stat returns datastore.ErrNoSuchEntity.

## Reader

```go
type Reader interface {
	io.Reader
	io.ReaderAt
	io.Seeker
}
```
Reader is a blob reader.

### func NewReader

```go
func NewReader(c context.Context, blobKey appengine.BlobKey) Reader
```
NewReader returns a reader for a blob. It always succeeds; if the blob does
not exist then an error will be reported upon first read.

## UploadURLOptions

```go
type UploadURLOptions struct {
	MaxUploadBytes        int64 // optional
	MaxUploadBytesPerBlob int64 // optional

	// StorageBucket specifies the Google Cloud Storage bucket in which
	// to store the blob.
	// This is required if you use Cloud Storage instead of Blobstore.
	// Your application must have permission to write to the bucket.
	// You may optionally specify a bucket name and path in the format
	// "bucket_name/path", in which case the included path will be the
	// prefix of the uploaded object's name.
	StorageBucket string
}
```
UploadURLOptions are the options to create an upload URL.